.nolist
include \masm32\include\masm32rt.inc
include \masm32\fpulib\fpu.inc
includelib \masm32\fpulib\fpu.lib
.686
include \masm32\macros\timers.asm

float2string	PROTO: DWORD, :DWORD
FloatToStrX	PROTO: QWORD, :PTR CHAR
xStrProc	PROTO: DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD

;     OPATTR guide
;     Bit	Set If...
;     0	References a code label
;     1	Is a memory expression or has a relocatable data label
;     2	Is an immediate expression
;     3	Uses direct memory addressing, i.e. is an absolute memory reference
;     4	Is a register expression
;     5	References no undefined symbols and is without error
;     6	References a stack location (usually a LOCAL variable or parameter)
;     7	References an external label
;     8-10	Language type (0=no type)
		; 76543210
atImmediate	equ 36	; 00100100
atGlobal	equ 42	; 00101010
atRegister	equ 48	; 00110000
atLocal	equ 98	; 01100010
;crash
flo$ MACRO strformat, arg1
LOCAL ArgType, atyB, ArgSize, tmp$, quotes, arg1a, arg1b, arg1c, mode$, AriMode, FF$, nustr
  ; % echo Args passed: <arg1>, <arg2>, <arg3>
  AriMode	= 0
  mode$	equ <>
  quotes	INSTR <strformat>, <">
  FF$		equ <0>
  if quotes eq 0
	quotes	INSTR <strformat>, <'>
  endif
  if quotes eq 1
	arg1a equ <arg1>			;; first arg is a format string
	FF$ equ <offset nustr>		;; we pass it as FF$
	.data
		nustr db strformat, 0			;; write arg to .DATA section
	.code
  else
	arg1a	equ <strformat>		;; first arg is the number
  endif
  arg1b	equ <0>
  arg1c	equ <0>
  IsDiv	INSTR	arg1a, </>
  IsMul	INSTR	arg1a, <*>
  IsPlus	INSTR	arg1a, <+>
  IsMinus	INSTR	arg1a, <->
  if IsMul
	arg1b SUBSTR arg1a, IsMul+1
	arg1a SUBSTR arg1a, 1, IsMul-1
	% echo Calc arg1a*arg1b
	mode$ CATSTR mode$, < mult>
	AriMode = 4
  endif
  if IsDiv
	if AriMode
		IsDiv INSTR arg1b, </>
		arg1c SUBSTR arg1b, IsDiv+1
		arg1b SUBSTR arg1b, 1, IsDiv-1
		AriMode = AriMode + 8*256
	else
		arg1b SUBSTR arg1a, IsDiv+1
		arg1a SUBSTR arg1a, 1, IsDiv-1
		AriMode = 8
	endif
;	% echo Calc arg1a/arg1b
	mode$ CATSTR mode$, < div>
  endif
  if IsPlus
	if AriMode
		IsPlus INSTR arg1b, <+>
		arg1c SUBSTR arg1b, IsPlus+1
		arg1b SUBSTR arg1b, 1, IsPlus-1
		AriMode = AriMode + 1*256
	else
		arg1b SUBSTR arg1a, IsPlus+1
		arg1a SUBSTR arg1a, 1, IsPlus-1
		AriMode = 1
	endif
;	% echo Calc arg1a+arg1b
	mode$ CATSTR mode$, < plus>
  endif
  if IsMinus gt 2
	if AriMode
		IsMinus INSTR arg1b, <->
		arg1c SUBSTR arg1b, IsMinus+1
		arg1b SUBSTR arg1b, 1, IsMinus-1
		AriMode = AriMode + 2*256
	else
		arg1b SUBSTR arg1a, IsMinus+1
		arg1a SUBSTR arg1a, 1, IsMinus-1
		AriMode = 2
	endif
;	% echo Calc arg1a-arg1b
	mode$ CATSTR mode$, < minus>
	AriMode = AriMode + 2
  endif
  atyB=(opattr(arg1b)) AND 127				;; needed when 123/MyRealX is implemented
;  tmp$ CATSTR <TypeB=>, %atyB
;  % echo tmp$
  ArgType=(opattr(arg1a)) AND 127			;; 0 no vn$, 36 immediate, 42 global, 48 CPU register, 98 local
  if ArgType eq atLocal or ArgType eq atGlobal
	ArgSize = SIZEOF arg1a	; 4 for DWORD, 10 for REAL10
  elseif ArgType eq atImmediate
;	tmp$ CATSTR <Moved immediate into edx: >, arg1a
;	% echo tmp$
	mov edx, arg1a
	arg1a equ <edx>
	ArgSize = 99			;; immediate integer
	ArgType = atRegister	;; we cheat
  elseif ArgType eq atRegister
	ArgSize SIZESTR arg1a
	if ArgSize eq 3
		ArgSize = 4			;; eax
	else
		ArgSize INSTR arg1a, <x>
		if ArgSize eq 0
			ArgSize=1		;; al, else ax
		endif
	endif
  else
	ArgSize = 444				; others
  endif
  tmp$ CATSTR <Type=>, %ArgType, <, Size=>, %ArgSize, < for >, arg1a, <, argB=>, arg1b, <, argC=>, arg1c, <, mode>, mode$
  % echo tmp$
  if ArgType ne atRegister
	arg1a CATSTR <addr >, arg1a
;	echo Addr added
  endif
  invoke xStrProc, FF$, arg1a, ArgSize, AriMode, arg1b, arg1c
  EXITM <offset f2sBuffer>
ENDM

; flo$(MyReal8a/3)
; crash
TestNum MACRO testnum:REQ
LOCAL tmp$
;	tmp$ CATSTR <">,<testnum>,<">
;	print chr$(tmp$, 9)
  if tproc eq 0
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		invoke FloatToStrX, testnum, addr f2sBuffer
		; int 3	; discards ST 6, 7, 8
	counter_end
	print ustr$(eax)," cycles with FloatToStr", 9
	print offset f2sBuffer, 13, 10

  elseif tproc eq 1
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		mov eax, flo$(testnum)
	counter_end
	ArgSize = SIZEOF testnum	; 4 for DWORD, 10 for REAL10
	tmp$ CATSTR <" cycles with xStr, Real>, %ArgSize, <">
	% print ustr$(eax),tmp$, 9
	print offset f2sBuffer, 13, 10

  elseif tproc eq 2
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		mov edx, offset testnum
		call F2sRay
	counter_end
	print ustr$(eax)," cycles with Ray's lib", 9
	print offset f2sBuffer, 13, 10

  else
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		INVOKE crt_sprintf, ADDR f2sBuffer, ADDR f2sFormat, testnum
	counter_end
	print ustr$(eax)," cycles with sprintf  ", 9
	print offset f2sBuffer, 13, 10

  endif
ENDM

ExRange equ 150

.data?
f2sP10	REAL8 ExRange*2 dup(?)
f2sDummy	dw ?
f2sBuffer	dd 80 dup(?)	; returned by flo$
f2sTmpBuf	dd 80 dup(?)	; internal buffer for f2sForm$

.data
MyReal8a	REAL8	+1.234567890123456789012345e5	; +6 still normal notation in sprintf
MyReal8b	REAL8	+1.234567890123456789012345e6	; -4 still normal notation in sprintf
MyReal8c	REAL8	-1.234567890123456789012345e-3	; rule: >-4 or <precision
MyReal8d	REAL8	-1.0e99
MyReal8e	REAL8	-0.0

MyReal10a	Real10	+1.234567890123456789012345e6
MyReal10b	Real10	+1.234567890123456789012345e-1
MyReal10c	Real10	-1.234567890123456789012345e-2
MyReal10d	Real10	-1.0e99
MyReal10e	Real10	0.0

MyReal4a	Real4	+1.23456789e3
MyReal4b	Real4	+1.23456789e9
MyReal4c	Real4	-1.23456789e-9
MyReal4d	Real4	-1.0e20
MyReal4e	Real4	0.0

MyReal10	REAL10	1234.567890123456789012345
f2sSeed	REAL10	1.0e+150	; e-ExRange-10 does not work
f2s0dot1	REAL10	0.1
testx	REAL10	3.3	;21928094887362
test3	REAL10	3.0

MyR4	REAL4	1.2345678e9

f2sFormat	db "%.6g", 0

ten	dq	10.0

ten_1	dt	1.0e1
	dt	1.0e2
	dt	1.0e3
	dt	1.0e4
	dt	1.0e5
	dt	1.0e6
	dt	1.0e7
	dt	1.0e8
	dt	1.0e9
	dt	1.0e10
	dt	1.0e11
	dt	1.0e12
	dt	1.0e13
	dt	1.0e14
	dt	1.0e15

ten_16	dt	1.0e16
	dt	1.0e32
	dt	1.0e48
	dt	1.0e64
	dt	1.0e80
	dt	1.0e96
	dt	1.0e112
	dt	1.0e128
	dt	1.0e144
	dt	1.0e160
	dt	1.0e176
	dt	1.0e192
	dt	1.0e208
	dt	1.0e224
	dt	1.0e240

ten_256	dt	1.0e256
; The remaining exponents are only necessary if we decide to support
; 10-byte doubles.  FloatToStr and StrToFloat only support 8-byte,
; but PowerOf10 doesn't care, so we'll include them.
	dt	1.0e512
	dt	1.0e768
	dt	1.0e1024
	dt	1.0e1280
	dt	1.0e1536
	dt	1.0e1792
	dt	1.0e2048
	dt	1.0e2304
	dt	1.0e2560
	dt	1.0e2816
	dt	1.0e3072
	dt	1.0e3328
	dt	1.0e3584
	dt	1.0e4096
	dt	1.0e4352
	dt	1.0e4608
	dt	1.0e4864
tenX	dd	0

.code

start:		if 0
			call MacTest
			exit
		endif

		f2sPrec = 6	; max 8 - 6 is standard for sprintf and FloatToStr

		UseInit = 1
		if UseInit
			finit
			print chr$(13, 10, "finit is ON", 10)
		else
			print chr$(13, 10, "finit is OFF", 10)
		endif

	; display size and FPU register preservation
	print chr$(13, 10, "FloatToStr", 9,"size=")
	mov eax, offset f2sL0
	sub eax, offset FloatToStrX
	add eax, offset tenX
	sub eax, offset ten
	print ustr$(eax)
	print chr$(", ST 6-8 trashed")

	print chr$(13, 10, "xStrProc",9,"size=")
	mov eax, offset f2sL1
	sub eax, offset xStrProc
	print ustr$(eax)
	print chr$(", all ST regs preserved")

	print chr$(13, 10, "Ray's lib",9,"size=ca. 700")
	print chr$(", all ST regs preserved")

	print chr$(13, 10, "sprintf   ",9,"size=000")
	print chr$(", all ST regs preserved", 13, 10, 10)

		LoopCount = 100000
		invoke Sleep, 500

		tproc=0				; 0 = FloatToStr ( Masm32 lib )
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal8a

		tproc=1				; 1 = xStrProc ( jj )
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal4a
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal8a
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal10a

		tproc=2				; 2 = Ray
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal10a

		tproc=3				; 3 = crt_sprintf ( C++ )
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal8a

		print chr$(13, 10, "---------", 10)

		tproc=0
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal8b

		tproc=1
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal4b
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal8b
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal10b

		tproc=2				; 2 = Ray
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal10b

		tproc=3				; 3 = crt_sprintf ( C++ )
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal8b

		print chr$(13, 10, "---------", 10)

		tproc=0
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal8c

		tproc=1
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal4c
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal8c
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal10c

		tproc=2				; 2 = Ray
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal10c

		tproc=3				; 3 = crt_sprintf ( C++ )
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal8c

		print chr$(13, 10, "---------", 10)

		tproc=0
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal8d

		tproc=1
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal4d
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal8d
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal10d

		tproc=2				; 2 = Ray
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal10d

		tproc=3				; 3 = crt_sprintf ( C++ )
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal8d

		print chr$(13, 10, "---------", 10)

		tproc=0
		; call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal8e

		tproc=1
		; call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal4e
		call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal8e
		; call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal10e

		tproc=2				; 2 = Ray
		; call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal10e

		tproc=3				; 3 = crt_sprintf ( C++ )
		; call LoadFPU		; finit, and writes data to all 8 registers
		TestNum MyReal8e

		print chr$(13, 10, "See the problem with FloatToStr for Real8=0.0?", 13, 10, "Result=")
		finit
		invoke FloatToStr, MyReal8e, addr f2sBuffer
		print offset f2sBuffer, 13, 10

		print flo$("\n\nNew flo$ macro:\nWe divide MyR4 (=1.2345678e9) by 12345678\nand add 11: Result=%f aka 111\nNow isn't that a cool macro?\n\n", MyR4/12345678+11)

		inkey "press a key to exit"
		exit

	; crash
	; MsgBox 0, edx, "ST$ test:", MB_OK

xStrProc proc	f2sForm$:DWORD,			; pointer to e.g. "The relation A:B is %f"
	arg1a:DWORD,			; pointer to the first number
	f2sSize:DWORD, f2sMode:DWORD,	; size (Int, R4, R8, R10) and mode: mul, div, add, sub
	arg1b:DWORD, arg1c:DWORD		; optional 2nd and 3rd numbers
LOCAL f2sSign:DWORD
LOCAL f2sST0:REAL10
LOCAL f2sST1:REAL10
LOCAL f2sTmp8:REAL8

COMMENT @ ------------------------------------------------------------------------------------------------------
This routine should be called through a macro, so
that the appropriate size can be chosen:

	ArgSize = SIZEOF testnum	; 4 for DWORD, 8 for REAL8, 10 for REAL10
	arg1a=offset testnum or ecx or 12345
	invoke xStrProc, arg1a, ArgSize, IsPlus+2*IsMinus+4*IsMul+8*IsDiv, arg1b

--------	jj August 2008 ---------------------------------------------------------------------------------------- @

	push edi
	push esi
	mov esi, offset f2sBuffer
	mov edi, f2sForm$		; do we have a string  la "The number %f is too small"?
	.if edi
			xor eax, eax
	@@:	mov al, [edi]
			test eax, eax
			je @F
			cmp al, "%"
			je @F

			mov cx, [edi]
			cmp cx, "n\"				; newline?
			jne NoLf
			sub eax, 92-13			; mov al, 13
			mov [esi], al
			inc esi
			inc edi
			sub eax, 3				; mov al, 10

	NoLf:	mov [esi], al
			inc edi
			inc esi
			jmp @B
	@@:	mov f2sForm$, edi		; we'll do the rest after we finished with the number
	.endif

	mov edi, arg1a				; addr to Number
	mov edx, offset f2sP10
	fstp f2sST0					; free two registers
	mov eax, [edx]
	fstp f2sST1
	.if eax==0
		fld f2s0dot1
		fld f2sSeed
		mov ecx, ExRange*2
@@:		fmul st, st(1)
		fst REAL8 ptr [edx]
		add edx, 8
		dec ecx
		jne @B
		fstp st					; pop 2 registers, 
		fstp st					; old ST0 will be on top again
	.endif

	fldlg2					; load constant, 8 cycles
	mov ecx, f2sSize
	.if ecx==10
		fld REAL10 ptr [edi]		; load from mem, 6 cycles
	.elseif ecx==8
		fld REAL8 ptr [edi]		; load from mem, 3 cycles
	.elseif ecx==4
		fld REAL4 ptr [edi]		; load from mem, 3 cycles
	.elseif ecx==99
		push arg1a
		fild dword ptr [esp]		; push an integer (reg or immediate)
		pop eax
	.endif
	mov ecx, f2sMode
	.if ecx
		push arg1b
		fild dword ptr [esp]
		pop eax
		.if cl==1	; add
			fadd
		.elseif cl==2
			fsub
		.elseif cl==4
			fmul
		.else
			fdiv
		.endif
		.if ch
			push arg1c
			fild dword ptr [esp]
			pop eax
			.if ch==1	; add
				fadd
			.elseif ch==2
				fsub
			.elseif ch==4
				fmul
			.else
				fdiv
			.endif
		.endif
		; MsgBox 0, str$(ecx), "Ecx=", MB_OK
	.endif
	fst f2sTmp8
	xor ecx, ecx				; sign flag
	ftst						; test for zero
	fstsw ax
	sahf
	jne @F
	mov eax, "0.0"
	mov f2sBuffer, eax
	jmp f2sZero

@@:	jnc @F					; jump if positive (not carry)
	inc ecx
	fabs

@@:	mov f2sSign, ecx
	fyl2x					; log, 196-329 cycles
	push eax				; create a stack slot
	fistp dword ptr [esp]		; get log10(num)
	mov ecx, [esp]			; truncate and put into ecx
;	.if eax==123
;		fld REAL4 ptr [edi]		; load from mem, 3 cycles
;	.endif
	; fld REAL8 ptr [edi]		; old
	fld f2sTmp8				; load from mem, 3 cycles - any chance to determine size at runtime?

;	.if eax==123
;		fld REAL10 ptr [edi]		; load from mem, 3 cycles
;	.endif
	lea edx, [f2sP10+8*ecx+8*ExRange-8*f2sPrec-8*2]		; max precision is 10
	fld REAL8 ptr [edx]
	fmul					; 16 cycles
	fistp dword ptr [esp]		; 29-34
	pop edx
	push ecx				; e counter + precision
	inc esi					; space for the dot
	invoke dwtoa, edx, esi
	mov ecx, len(esi)
	mov al, [esi+ecx-1]
	mov ah, [esi+ecx-2]
	.if al>"4"
		inc ah
	.endif
	mov [esi+ecx-2], ah
	push ecx
	mov ax, [esi]
	mov [esi]-1, ax
	add esi, f2sSign
	mov al, "."	; dot
	mov [esi], al
	mov eax, "0+e"
	pop ecx
	sub ecx, f2sSign
	add esi, ecx
	mov [esi-1], eax
	pop ecx							; e counter
	.if ecx<100
		inc esi						; shift one to the right to allow for leading "0"
	.endif
	mov edi, ecx
	inc esi
	invoke lstrcpy, esi, str$(ecx)		; add the exponent
	.if sdword ptr edi<0
		mov ax, "0-"
		mov [esi-1], ax
	.endif
f2sZero:
	mov edi, f2sForm$				; do we have a leftover from the format string?
	.if edi
	@@:	lodsb
			test al, al
			jne @B
			add edi, 2				; get rid of %f
			dec esi
	@@:	mov al, [edi]
			test al, al
			je @F

			mov cx, [edi]
			cmp cx, "n\"				; newline?
			jne NoLf2
			sub eax, 92-13			; mov al, 13
			mov [esi], al
			inc esi
			inc edi
			sub eax, 3				; mov al, 10

	NoLf2:	mov [esi], al
			mov [esi], al
			inc esi
			inc edi
			jmp @B
	@@:
	.endif
	pop esi
	pop edi
	fld f2sST1						; restore 2 registers
	fld f2sST0
  ret
xStrProc endp
f2sL1:

LoadFPU proc
		if UseInit
			finit
		endif
		xor eax, eax	; test: load all 8 FPU regs
		mov ecx, 8
@@:		inc eax
		push eax
		fild dword ptr [esp]
		pop eax
		dec ecx
		jne @B
;		pushad
;		print chr$(13, 10, "Init", 13,10)
;		popad
		ret
LoadFPU endp

F2sRay proc
  if 0
	ffree st(7)
	fld REAL8 ptr [edx]		; load from mem, 3 cycles - any chance to determine size at runtime?
  endif
  invoke FpuFLtoA, edx, 6, offset f2sBuffer, SRC1_REAL or SRC2_DIMM or STR_SCI
  ret
F2sRay endp

if 1
MacTest proc
Local MyLocal4:REAL4, MyLocal8:REAL8, MyLocal10:REAL10
	print chr$(13, 10, "We divide MyReal4a by 1234: ")
				mov ecx, 12345678
	print flo$(MyReal4a*10000000/ecx)
	print chr$(13, 10, "We multiply MyReal4a by 1000: ")
	print flo$(MyReal4a*1000)
	print chr$(13, 10, "We calculate 12*1000+345: ")
	print flo$(12*1000+345)
	print chr$(13, 10, "We calculate 0*1000+345: ")
	print flo$("\nThe number %f is far too big", 12*1000+345)
	if 0
	print flo$(MyReal8)			; print fld, fst, crt_sprintf
	print flo$(MyReal10)			; print fld, fst, crt_sprintf
	print flo$(MyReal10*123)		; print fld, fst, crt_sprintf
	print flo$(MyInt4)			; fild, fst, crt_sprintf
	print flo$(MyLocal8)			; crt_sprintf
	print flo$(MyLocal4)			; print fld, fst, crt_sprintf
	print flo$(MyLocal10)		; print fld, fst, crt_sprintf
	print flo$(MyLocal10*123)		; print fld, fst, crt_sprintf
	print flo$("123.456")			; just copy
	print flo$(-1)			; pop ST(0)
	print flo$(0, addr bf)			; fst ST(0), write to bf
	print flo$(1)			; fst ST(1)
	print flo$(eax, edx)			; fild eax, write to edx
	print flo$(AX, edx)			; fild eax, write to edx
	print flo$(al, edx)			; fild eax, write to edx
	print flo$(eax/edx)			; fild eax, fild edx, div
	print flo$(eax/1024, edx)		; fild eax, push and divide 1024, write to edx
	; print flo$(1, "A float: %.7e", addr bf)	; don't use f2sFormat
	; print flo$("%.5g")			; plain ST(0), don't use f2sFormat
	; print flo$("ST(0) contains %.5g")	; don't use f2sFormat
	; print flo$(-1, "ST(0) contained %.5g")	; don't use f2sFormat
	; print flo$(1, "ST(1) contains %.5g")	; don't use f2sFormat
	print flo$(ST(3))			; 
	print flo$(ST)			; 
	print flo$(st(2))			; 
	; print flo$(mm0)			; 
	; print flo$(mm3)			; 
	endif
  ret
MacTest endp

float2string proc uses esi f2sNum:DWORD, f2sBuf:DWORD
	INVOKE crt_sprintf, ADDR f2sBuffer, ADDR f2sFormat, REAL8 PTR [eax]
	mov edx, offset f2sBuffer
  ret
float2string endp
endif
if 0
CopyMem	PROTO: DWORD, :DWORD, :DWORD	; GeneSys

align 4
CopyMem proc uses esi edi lpSource:DWORD,lpDest:DWORD,bcount:DWORD
;--------------------------------------- adapted from GeneSys, this version 32 bytes
;    push    esi
;    push    edi
;    cld                                 ; Clear direction flag
    mov     esi, lpSource               ; Source address in ESI
    mov     edi, lpDest                 ; Destination address in EDI
    mov     ecx, bcount                 ; Byte count to copy in ECX
	push	ecx
    shr     ecx, 2                      ; Divide count by 4
    rep     movsd                       ; Copy DWORD size blocks
	pop		ecx
;	 mov     ecx, bcount                 ; Reload byte count
    and     ecx, 3                      ; Calculate remainder
    rep     movsb                       ; Copy tail
;    pop     edi
;    pop     esi
    ret
;---------------------------------------
CopyMem endp

Dummy proc
  push esi
  pop esi
  ret
Dummy endp
endif
; Tim N. Roberts.


; These are bits in the FP status word.

FP_LESSTHAN	equ	01h
FP_EQUALTO	equ	40h

	.data

; I'd rather this was local to the procedure, but masm doesn't do 
; local arrays correctly.

szTemp	db	18 dup (0)

	.code

PowerOf10	proto

;ten	dq	10.0
ten7	dq	1.0e6
;ten17	dq	1.0e17
;rounder	dq	5.0e10


; Convert a floating point register to ASCII.  For internal use.
; The result always has exactly 18 digits, with zero padding on the
; left if required.
;
; Entry:	ST(0) = a number to convert, 0 <= ST(0) < 1E19.
;		szTemp = an 18-character buffer.
;
; Exit:		szTemp = the converted result.

FloatToBCD	PROC	public uses esi edi

    sub esp, 10

	; The fbstp instruction converts the top of the stack to a
	; packed BCD form in ten bytes, with two digits per byte.  The top 
	; byte has the sign, which we ignore.

    fbstp [esp]

	; Now we need to unpack the BCD to ASCII.

    lea esi, [esp+8]
    lea edi, [szTemp]
    mov ecx, 9

    .REPEAT
	mov al, [esi]          ; xxxx xxxx AAAA BBBB
	dec esi
	rol ax, 12             ; BBBB xxxx xxxx AAAA
	rol ah, 4              ; xxxx BBBB xxxx AAAA
	and ax, 0f0fh          ; 0000 BBBB 0000 AAAA
	add ax, 3030h          ; 3B3A
	mov [edi], ax
	add edi, 2
	dec ecx
    .UNTIL ZERO?

    add esp, 10
    ret

FloatToBCD	ENDP

;
; Convert a double precision number to a string.
;
; Entry:	fpin = 8-byte double to convert
;		szDbl = character buffer
;
; Exit:		szDbl = converted value
;
; szDbl should be at least 19 bytes long.
;		

FloatToStrX	PROC	stdcall public USES esi edi, 
		fpin: QWORD, 
		szDbl: PTR CHAR

    LOCAL	iExp: DWORD
    LOCAL	stat: WORD
    LOCAL	mystat: WORD

; Special case zero.  fxtract fails for zero.
	
    mov edi, [szDbl]

    .if	(dword ptr [fpin] == 0) && (dword ptr [fpin][4] == 0)
      mov byte ptr [edi], '0'
      mov byte ptr [edi][1], 0
      ret
    .endif

; Check for a negative number.

    .if	(sdword ptr [fpin][4] < 0)
      and byte ptr [fpin][7], 07fh	; change to positive
      mov byte ptr [edi], '-'		; store a minus sign
      inc edi
    .endif

; Initialize the floating point unit and load our value onto the stack.

    fclex
    fstcw [stat]
    mov [mystat], 027fh
    fldcw [mystat]

    fld [fpin]
    fld st(0)

; Compute the closest power of 10 below the number.  We can't get an
; exact value because of rounding.  We could get close by adding in
; log10(mantissa), but it still wouldn't be exact.  Since we'll have to
; check the result anyway, it's silly to waste cycles worrying about
; the mantissa.
;
; The exponent is basically log2(fpin).  Those of you who remember
; algebra realize that log2(fpin) x log10(2) = log10(fpin), which is
; what we want.

    fxtract			; ST=> mantissa, exponent, fpin
    fstp st(0)			; drop the mantissa
    fldlg2			; push log10(2)
    fmulp st(1), st		; ST = log10(fpin), fpin
    fistp [iExp]		; ST = fpin

; An 8-byte double can carry almost 16 digits of precision.  Actually, it's
; 15.9 digits, so some numbers close to 1E17 will be wrong in the bottom
; digit.  If this is a concern, change the '16' to a '15'.
;
; A 10-byte double can carry almost 19 digits, but fbstp only stores the
; guaranteed 18.  If you're doing 10-byte doubles, change the '16' to '18'.

    .IF	([iExp] < 16)
      fld st(0)			; ST = fpin, fpin
      frndint			; ST = int(fpin), fpin
      fcomp st(1)		; ST = fpin, status set
      fstsw ax
      .IF (ah & FP_EQUALTO)	; if EQUAL

; We have an integer!  Lucky day.  Go convert it into a temp buffer.

	call FloatToBCD

	mov eax, 17
	mov ecx, [iExp]
	sub eax, ecx
	inc ecx
	lea esi, [szTemp][eax]

; The off-by-one order of magnitude problem below can hit us here.  
; We just trim off the possible leading zero.

	.IF (byte ptr [esi] == '0')
	  inc esi
	  dec ecx
	.ENDIF

; Copy the rest of the converted BCD value to our buffer.

	rep movsb
	jmp ftsExit

      .ENDIF
    .ENDIF

; We use the format [-]d.ddddddE+ddd.  That means we only need a maximum
; of 7 decimal places.  Let's have fbstp do our rounding for us.

    mov eax, 6
    sub eax, [iExp]	; adjust exponent to 7
    call PowerOf10X

; Either we have exactly 7 digits, or we have exactly 6 digits.  We can
; detect that condition and adjust now.

    fcom [ten7]
    ; x0xxxx00 means top of stack > ten7
    ; x0xxxx01 means top of stack < ten7
    ; x1xxxx00 means top of stack = ten7
    fstsw ax
    .IF (ah & 1)
      fmul [ten]
      dec iExp
    .ENDIF

; Go convert to BCD.

    call FloatToBCD

    lea esi, [szTemp+11]	; point to converted buffer

; If the exponent is between -1 and 6, we can express this as a number
; without scientific notation.

    mov ecx, iExp
    .IF (SDWORD PTR ecx >= -1) && (SDWORD PTR ecx <= 6)

; We need to copy ecx+1 digits, then a decimal point (maybe), then 
; the remaining 6-ecx digits.  If exponent is 0, add a leading 0.

      .IF (SDWORD PTR ecx == -1)
	mov byte ptr [edi], '0'
	inc edi
      .ENDIF

      inc ecx
      rep movsb
      mov byte ptr [edi], '.'
      inc edi
      mov ecx, 6
      sub ecx, [iExp]
      rep movsb

; Trim off trailing zeros.

      .WHILE (byte ptr [edi-1] == '0')
	dec edi
      .ENDW

; If we cleared out all the decimal digits, kill the decimal point, too.

      .IF (byte ptr [edi-1] == '.')
	dec edi
      .ENDIF

; That's it.

      jmp ftsExit

    .ENDIF


; Now convert this to a standard, usable format.  If needed, a minus
; sign is already present in the outgoing buffer, and edi already points
; past it.

    movsb				; copy the first digit
    mov byte ptr [edi], '.'		; plop in a decimal point
    inc edi
    movsd				; copy four more digits
    movsw				; copy two more digits

if 0

; The printf %g specified trims off trailing zeros here.  I dislike
; this, so I've disabled it.  Comment out the if 0 and endif if you
; want this.

    .WHILE (byte ptr [edi][-1] == '0')
      dec edi
    .ENDW
endif

; Shove in the exponent.  If you support 10-byte reals, remember to
; allow 4 digits for the exponent.

    mov byte ptr [edi], 'e'	; start the exponent
    mov eax, [iExp]
    .IF (sdword ptr eax < 0)	; plop in the exponent sign
      mov byte ptr [edi][1], '-'
      neg eax
    .ELSE
      mov byte ptr [edi][1], '+'
    .ENDIF

    mov ecx, 10

    xor edx, edx
    div ecx
    add dl, '0'
    mov [edi][4], dl	; shove in the ones exponent digit

    xor edx, edx
    div ecx
    add dl, '0'
    mov [edi][3], dl	; shove in the tens exponent digit

    xor edx, edx
    div ecx
    add dl, '0'
    mov [edi][2], dl	; shove in the hundreds exponent digit

    add edi, 5		; point to terminator

; Clean up and go home.

ftsExit:
    mov byte ptr [edi], 0
    fldcw [stat]		; restore control word
    fwait

    ret
FloatToStrX	ENDP

PowerOf10X	PROC	public

    mov ecx, eax
    .IF	(SDWORD PTR eax < 0)
	neg eax
    .ENDIF

    fld1

    mov dl, al
    and edx, 0fh
    .IF	(!ZERO?)
	lea edx, [edx+edx*4]
	fld ten_1[edx*2][-10]
	fmulp st(1), st
    .ENDIF

    mov dl, al
    shr dl, 4
    and edx, 0fh
    .IF (!ZERO?)
	lea edx, [edx+edx*4]
	fld ten_16[edx*2][-10]
	fmulp st(1), st
    .ENDIF

    mov dl, ah
    and edx, 1fh
    .IF (!ZERO?)
	lea edx, [edx+edx*4]
	fld ten_256[edx*2][-10]
	fmulp st(1), st
    .ENDIF

    .IF (SDWORD PTR ecx < 0)
	fdivp st(1), st
    .ELSE
	fmulp st(1), st
    .ENDIF

    ret

PowerOf10X	ENDP
f2sL0:

end start
OPT_Linker	polink
OPT_Icon	Calc
OPT_WAIT	1
OPT_Susy	CONSOLE
OPT_Tmp2Asm	1
